#include<stdarg.h>
#include <3048fone.h>
#include "h8_3048fone.h"

#define SYS_CLOCK 25 /*MHz 16,20,25 xz*/


unsigned char P1DDR=0,P2DDR=0,P3DDR=0,P4DDR=0,P5DDR=0;
unsigned char  P6DDR=0,P7DDR=0,P8DDR=0,P9DDR=0,PADDR=0,PBDDR=0;

/*SCI֌W̊{͊}N(1998Nx)N(2000)̊Jł*/
/* ------------------------------------------------- */
/* SCI1 INITIALIZATION fixed baud at 38400           */
/* ------------------------------------------------- */
void initSCI1()
{
	short int i;
	SCI1.SCR.BYTE = 0;       /* clear all flags */
					  /* 2400-38400baud are available at n=0(cks1=0,cks2=0) */
	SCI1.SMR.BYTE = 0;       /* Async, 8bit , NoParity, stop1, 1/1 */
	/*SCI1.BRR = 19;          /* 38400baud (CPU=25MHz) */
	SCI1.BRR = (unsigned char)((8138L*SYS_CLOCK+5000L)/10000L-1);
	for(i=0;i<1000;i++);      /* wait more than 1bit time */
	SCI1.SCR.BYTE = 0x30;    /* scr = 0011 0000 (TE=1,RE=1) */
	return;
}

/* ------------------------------------------------- */
/* GET BYTE FROM SCI1 */
/* ------------------------------------------------- */
short int SCI1_getChar()
/* return value 0x00-0xFF:received data */
/*              -2(0xFFFE):error */
{
	short int flags,recdata;
	do {
		flags = SCI1.SSR.BYTE;
		if (flags&0x38) {/* error */
			SCI1.SSR.BIT.RDRF = 0;
			SCI1.SSR.BIT.ORER = 0;
			SCI1.SSR.BIT.FER = 0;
			SCI1.SSR.BIT.PER = 0;
			return -2;
		}
		if (flags&0x40) {/* normally received one data */
			SCI1.SSR.BIT.RDRF = 0;
			recdata=SCI1.RDR;
			return recdata;
		}
	} while (1);
}

/* ------------------------------------------------- */
/* CHECK SCI BUFFER AND GET DATA */
/* ------------------------------------------------- */
short int SCI1_chkgetChar()
/* return value -1(0xFFFF):no received data  */
/*              0x00-0xFF:received data */
/*              -2(0xFFFE):error */
{
	short int flags,recdata;
	flags = SCI1.SSR.BYTE;
	if (flags&0x38) {/* error */
		SCI1.SSR.BIT.RDRF = 0;
		SCI1.SSR.BIT.ORER = 0;
		SCI1.SSR.BIT.FER = 0;
		SCI1.SSR.BIT.PER = 0;
		return -2;
	}
	if (flags&0x40) {/* normally received one data */
		recdata=SCI1.RDR;
		SCI1.SSR.BIT.RDRF = 0;
		return recdata;
	} else {
		return -1;
	}
}

void SCI1_putString(char *str);

/*SCI1蕶[return]I[C'\n'͎擾Ȃ*/
/*^HŃobNXyCX*/
int SCI1_getString(char *buff,int max)
{
	int i,ch;
	for (i=0;i<max-1;i++) {
		ch=SCI1_getChar(); /*1擾*/
		*buff=(char)ch; /*1擾*/
		if (*buff=='\r'||ch<0) {
			*buff=0;
			return i+1;
		}
		if (*buff==0x8) {
			buff-=2;
			i-=2;
		}
		if (*buff!='\n') buff++;
		else i--;
	}
	*buff=0;
	return i+1;
}

short int atoi(char *buff)
{
	int x=0,y,m=0,n=0,v=0,i=0;
	y=buff[i];
	while(y!=0){
		if(y=='-') m=1;
		if('a'<=y&&y<='z') y=y-'a'+'A';
		if(y=='0') n=1;

		if(v==1){
			if('0'<=y&&y<='9'){
				y=y-'0';
			}
			else if('A'<=y&&y<='F'){
				y=y-'A'+10;
			}
			x=16*x+y;
		}

		if(n==1&&y=='X'){
			v=1;
		}
				
		if(v==0&&'0'<=y&&y<='9'){
			y=y-'0';
			x=10*x+y;
		}

		y=buff[++i];
	}
	if(m==1) x=-x;
	return x;
}

/*SCI1փvvg\āCSCI1萮l*/
short int SCI1_getInt(char prompt[])
/*getting integer from serial port*/
/* format 123[ret] */
/*        -123[ret] */
/*        0x1a[ret] */
/*        -0x100[ret] */
{
	int x=0,y,m=0,n=0,v=0,i=0;
	char buff[16];
	SCI1_putString(prompt);
	SCI1_getString(buff,16);
	return atoi(buff);
}

/* ------------------------------------------------- */
/* PUT BYTE TO SCI1 */
/* ------------------------------------------------- */
void SCI1_putChar(char c)
{
	unsigned char tmp;
/*	if (c=='\n') SCI1_putChar('\r');*/
	do{
		tmp = SCI1.SSR.BYTE;
	} while((tmp & 0x80)==0);
	SCI1.TDR = c;
	SCI1.SSR.BIT.TDRE = 0;
	return;
}

void SCI1_putString(char *str)
{
	while(*str){
		SCI1_putChar(*str);
		str++;
	}
}


/* ------------------------------------------------- */
/* SCI0 INITIALIZATION fixed baud at 38400           */
/* ------------------------------------------------- */
void initSCI0()
{
	short int i;
	SCI0.SCR.BYTE = 0;       /* clear all flags */
					  /* 2400-38400baud are available at n=0(cks1=0,cks2=0) */
	SCI0.SMR.BYTE = 0;       /* Async, 8bit , NoParity, stop1, 1/1 */
	/*SCI0.BRR = 19;          /* 38400baud (CPU=25MHz) */
	SCI0.BRR = (unsigned char)((8138L*SYS_CLOCK+5000L)/10000L-1);
	for(i=0;i<1000;i++);      /* wait more than 1bit time */
	SCI0.SCR.BYTE = 0x30;    /* scr = 0011 0000 (TE=1,RE=1) */
	return;
}

/* ------------------------------------------------- */
/* GET BYTE FROM SCI0 */
/* ------------------------------------------------- */
short int SCI0_getChar()
/* return value 0x00-0xFF:received data */
/*              -2(0xFFFE):error */
{
	short int flags,recdata;
	do {
		flags = SCI0.SSR.BYTE;
		if (flags&0x38) {/* error */
			SCI0.SSR.BIT.RDRF = 0;
			SCI0.SSR.BIT.ORER = 0;
			SCI0.SSR.BIT.FER = 0;
			SCI0.SSR.BIT.PER = 0;
			return -2;
		}
		if (flags&0x40) {/* normally received one data */
			SCI0.SSR.BIT.RDRF = 0;
			recdata=SCI0.RDR;
			return recdata;
		}
	} while (1);
}

/* ------------------------------------------------- */
/* CHECK SCI BUFFER AND GET DATA */
/* ------------------------------------------------- */
short int SCI0_chkgetChar()
/* return value -1(0xFFFF):no received data  */
/*              0x00-0xFF:received data */
/*              -2(0xFFFE):error */
{
	short int flags,recdata;
	flags = SCI0.SSR.BYTE;
	if (flags&0x38) {/* error */
		SCI0.SSR.BIT.RDRF = 0;
		SCI0.SSR.BIT.ORER = 0;
		SCI0.SSR.BIT.FER = 0;
		SCI0.SSR.BIT.PER = 0;
		return -2;
	}
	if (flags&0x40) {/* normally received one data */
		recdata=SCI0.RDR;
		SCI0.SSR.BIT.RDRF = 0;
		return recdata;
	} else {
		return -1;
	}
}

void SCI0_putString(char *str);

/*SCI0蕶[return]I[C'\n'͎擾Ȃ*/
/*^HŃobNXyCX*/
int SCI0_getString(char *buff,int max)
{
	int i,ch;
	for (i=0;i<max-1;i++) {
		ch=SCI0_getChar(); /*1擾*/
		*buff=(char)ch; /*1擾*/
		if (*buff=='\r'||ch<0) {
			*buff=0;
			return i+1;
		}
		if (*buff==0x8) {
			buff-=2;
			i-=2;
		}
		if (*buff!='\n') buff++;
		else i--;
	}
	*buff=0;
	return i+1;
}

/*SCI0փvvg\āCSCI0萮l*/
short int SCI0_getInt(char prompt[])
/*getting integer from serial port*/
/* format 123[ret] */
/*        -123[ret] */
/*        0x1a[ret] */
/*        -0x100[ret] */
{
	int x=0,y,m=0,n=0,v=0,i=0;
	char buff[16];
	SCI0_putString(prompt);
	SCI0_getString(buff,16);
	return atoi(buff);
}

/* ------------------------------------------------- */
/* PUT BYTE TO SCI0 */
/* ------------------------------------------------- */
void SCI0_putChar(char c)
{
	unsigned char tmp;
	if (c=='\n') SCI0_putChar('\r');
	do{
		tmp = SCI0.SSR.BYTE;
	} while((tmp & 0x80)==0);
	SCI0.TDR = c;
	SCI0.SSR.BIT.TDRE = 0;
	return;
}

void SCI0_putString(char *str)
{
	while(*str){
		SCI0_putChar(*str);
		str++;
	}
}



/* Port3 -> LCD */
/* 7    6    5    4    3    2    1    0  */
/*          ES   RS  DB7  DB6  DB5  DB4  */

/* i/o */
#define init_LCD_Port()     P3.DDR = 0x3f
#define LCD_Port            P3.DR.BYTE
#define LCD_RegisterSelect  P3.DR.BIT.B4
#define LCD_EnableSignal    P3.DR.BIT.B5

static void LCD_msecwait(unsigned int msec)
/*mescԂȂɂȂԉ҂֐*/
{
	int i,j;
	for (i=0;i<msec;i++) {
		for (j=0;j<168*SYS_CLOCK;j++);
	}
}

static void LCD_microsecwait(unsigned int microsec)
{/*microsecԂȂɂȂԉ҂֐*/
	int i,j;
	for (i=0;i<microsec;i++) {
		for (j=0;j<4;j++);
	}
}

static void LCD_putCommand(char command) /*command width must be 4bits*/
{
	LCD_Port=(LCD_Port&0xf0)|command;
	LCD_EnableSignal=1;
	LCD_microsecwait(5);
	LCD_EnableSignal=0;
	LCD_microsecwait(40);
}

static void LCD_putCommand2(char command2)
{
	LCD_putCommand((command2>>4)&0xf);
	LCD_putCommand(command2&0xf);
}

/************************************************************
LCDɌ putchar()
************************************************************/
void LCD_putChar(char data)
{
	LCD_RegisterSelect=1;
	LCD_putCommand((data>>4)&0xf);
	LCD_putCommand(data&0xf);
	LCD_RegisterSelect=0;
}

/************************************************************
LCDɌ puts()
************************************************************/
void LCD_putString(char *str)
{
	while(*str) LCD_putChar(*str++);
}

/************************************************************
LCD̏
************************************************************/
void initLCD( void )
{
	init_LCD_Port();        /* output */
	LCD_Port&=0xc0;
	LCD_msecwait(30);           /* wait 30ms */
	LCD_putCommand(0x3);     /* function set */
	LCD_microsecwait(4100);
	LCD_putCommand(0x3);     /* function set */
	LCD_microsecwait(100);
	LCD_putCommand(0x3);     /* function set */
	LCD_microsecwait(100);
	LCD_putCommand(0x2);     /* function set data width=4bit*/
	LCD_putCommand2(0x28);   /* function set 4bit duty:1/16,size:5*7 */
	LCD_putCommand2(0x0c);   /* display on,cursor off,blink off */
	LCD_putCommand2(0x06);   /* address:auto increment,cursor shift:right */
	LCD_putCommand2(0x01);   /* clear display */
	LCD_microsecwait(1640);
}

/************************************************************
LCDɌ gotoxy()
************************************************************/

void LCD_gotoxy(unsigned x,unsigned y)
{
	unsigned char point;
	point=0x80+x+0x40*y;
	LCD_putCommand2(point);
}

/************************************************************
LCDɌ clrscr()   clear screen
************************************************************/
void LCD_clrscr(void)
{
	LCD_putCommand2(0x01);    /* clear display */
	LCD_microsecwait(1640);
}

/************************************************************
Device_printf
************************************************************/

const char hexstring[]="0123456789abcdef0123456789ABCDEF";
#define MAXDIGIT 34
const int SCI0device=0;
const int SCI1device=1;
const int LCDdevice= 2;
const int STRdevice= 3;

static char *currentstrptr;
static void STR_putChar(char ch)
{
	*currentstrptr++=ch;
	*currentstrptr=0;
}

static void STR_putString(char *ptr)
{
	while(*ptr) STR_putChar(*ptr++);
}


void Device_printf(int device, char *format, va_list arg_ptr)
{
	void (*device_putchar)(char ch);
	void (*device_puts)(char *ptr);
	char buf[MAXDIGIT];
	unsigned char flag=0;  /*%d:bit2 l:bit1 %:bit0 */
	unsigned char digit=0; /*  */
	unsigned char minus=0;
	char fill=' ',format1=' ';
	unsigned char radix=10; /*Ni*/
	char sign=' ';
	char *ptr=buf; /*o͕|C^*/
	unsigned char cntr=0; /*o͕JE^*/
	unsigned char shift=0; /*16iVtg 0 or 6*/
	unsigned char i;
	unsigned long int value=0;
	if (device==SCI0device) {
		device_putchar=SCI0_putChar;
		device_puts=SCI0_putString;
	} else if (device==SCI1device) {
		device_putchar=SCI1_putChar;
		device_puts=SCI1_putString;
	} else if (device==LCDdevice) {
		device_putchar=LCD_putChar;
		device_puts=LCD_putString;
	} else { /*device==STRdevice*/
		device_putchar=STR_putChar;
		device_puts=STR_putString;
	}
	/*va_start(arg_ptr,format);*/
	while (*format) {
		format1=*format;
		if (flag==0) {
			if (format1=='%') {
				flag=1;
				digit=0;
				fill=' ';
				minus=0;
				radix=0;
				ptr=&buf[MAXDIGIT-1];
				*ptr--='\0';
				cntr=0;
				shift=0;
				sign='+';
			} else {
				device_putchar(format1);
			}
		} else {
			if (format1=='l') {
				flag|=2;
			} else if ('0'<=(format1)&&(format1)<='9') {
				if (digit==0 && format1=='0') {
					fill='0';
				} else {
					digit=digit*10+((format1)-'0');
					if (MAXDIGIT-2<digit) digit=MAXDIGIT-2;
				}
			} else if (format1=='-') {
				minus=1;
			} else if (format1=='d') {
				flag|=4;
				radix=10;
			} else if (format1=='u') {
				radix=10;
			} else if (format1=='x') {
				radix=16;
			} else if (format1=='X') {
				radix=16;shift=16;
			} else if (format1=='o') {
				radix=8;
			} else if (format1=='b') {
				radix=2;
			} else if (format1=='p') {
				radix=16;shift=16;digit=8;fill='0';flag|=2;
			} else if (format1=='c') {
				device_putchar((unsigned char)(va_arg(arg_ptr,int)));
				flag=0;
			} else if (format1=='s') {
				if (digit) {
					cntr=0;ptr=va_arg(arg_ptr,char *);
					while (ptr[cntr]) cntr++; /*cntr͕*/
					if (!minus) for (i=cntr;i<digit;i++) device_putchar(' ');
					device_puts(ptr);
					if (minus) for (i=cntr;i<digit;i++) device_putchar(' ');
				} else {
					device_puts(va_arg(arg_ptr,char *));
				}
				flag=0;
			} else {
				device_putchar(format1);
				flag=0;
			}
			if (radix) {
				switch (flag&6) {
				case 0: /* unsig int */
					value=(unsigned int)va_arg(arg_ptr,int);
					break;
				case 2: /* unsig long int */
					value=va_arg(arg_ptr,long int);
					break;
				case 4: /* sig int */
					value=(long int)va_arg(arg_ptr,int);
					if ((long int)value<0) {
						value=-(long int)value;
						sign='-';
					}
					break;
				case 6: /* sig long int */
					value=va_arg(arg_ptr,long int);
					if ((long int)value<0) {
						value=-(long int)value;
						sign='-';
					}
					break;
				default:
					break;
				}
				while (value) {
					*ptr--=hexstring[value%radix+shift];
					cntr++;
					value/=radix;
				}
				if (cntr==0) {
					*ptr--='0';
					cntr++;
				}
				if (fill==' ') {
					if (sign=='-') {
						*ptr--='-';
						cntr++;
					}
					if (!minus) for (i=cntr;i<digit;i++) device_putchar(' ');
					device_puts(++ptr);
					if (minus) for (i=cntr;i<digit;i++) device_putchar(' ');
				} else {
					for (;cntr<digit-1;cntr++) *ptr--='0';
					if (sign!='-'&&cntr<digit) *ptr--='0';
					else if (sign=='-') *ptr--='-';
					device_puts(++ptr);
				}
				flag=0;
			}
		}
		format++;
	}
	/*va_end(arg_ptr);*/
}

void SCI0_printf(char *format,...)
{
	va_list arg;
	va_start(arg, format);
	Device_printf(SCI0device, format, arg);
	va_end(arg);
}

void SCI1_printf(char *format,...)
{
	va_list arg;
	va_start(arg, format);
	Device_printf(SCI1device, format, arg);
	va_end(arg);
}

void LCD_printf(char *format,...)
{
	va_list arg;
	va_start(arg, format);
	Device_printf(LCDdevice, format, arg);
	va_end(arg);
}

void sprintf(char *buff,char *format,...)
{
	va_list arg;
	va_start(arg, format);
	currentstrptr=buff;
	Device_printf(STRdevice, format, arg);
	va_end(arg);
}
/* ------------------------------------------------- */
/* LED INITIALIZATION */
/* ------------------------------------------------- */
/**********************************************************
LED 0:P5-0
LED 1:P5-1
LED 0:P5-2
LED 1:P5-3
**********************************************************/
void initLed()
{
	P5DDR |=  0xf;
	P5.DDR = P5DDR;
}

/* ------------------------------------------------- */
/* LET LED ON */
/* ------------------------------------------------- */
/*number0܂1*/
void turnOnLed(short int number)
{ 
	static const unsigned char mask[]={1,2,4,8};
	P5.DR.BYTE |=mask[number];
}

/* ------------------------------------------------- */
/* LET LED OFF */
/* ------------------------------------------------- */
/*number0܂1*/
void turnOffLed(short int number)
{
	static const unsigned char mask[]={0xfe,0xfd,0xfb,0xf7};
	P5.DR.BYTE &=mask[number];
}

/* ------------------------------------------------- */
/* PUSH SW INITIALIZATION */
/* ------------------------------------------------- */
/**********************************************************
{^XCb`S0FP4-4
{^XCb`S1FP4-5
{^XCb`S2FP4-6
{^XCb`S3FP4-7
**********************************************************/
void initPushSW(void)
{
	P4DDR &= 0xf; /*P4-4,5,6,7͓*/
	P4.DDR=P4DDR;
	P4.PCR.BYTE|=0xf0; /*P4-4,5,6,7̓vAbv */
}

/* ------------------------------------------------- */
/* GET PUSH SW  */
/* ------------------------------------------------- */
/*push sw̏Ԃ̂܂ܕԂ*/
short int getPushSW(void)
{
	return (((unsigned char)(~P4.DR.BYTE))&0xf0);
}

short int checkPushSW(short int number)
/*push sw 0,1,2,3̏Ԃ𒲂ׂ@number:0,1,2,or 3*/
/*Ă1AłȂ0Ԃ*/
{
	short int ret;
	static const unsigned char mask[]={0x10,0x20,0x40,0x80};
	if (P4.DR.BYTE&mask[number]) ret=0;
	else ret=1;
	return ret;
}

/* ------------------------------------------------- */
/* PUSH 8 BIT SW INITIALIZATION */
/* ------------------------------------------------- */
void init8BitSW(void)
{
	P2DDR &=  0x00;/*8bitSW̃|[g͂ɐݒ*/
	P2.DDR = P2DDR;
	P2.PCR.BYTE = 0xff;/*8bitSW̃vAbvݒ*/
}

/*8bitsw̏Ԃ̂܂ܕԂ*/
short int get8BitSW(void)
{
	return (unsigned char)(~P2.DR.BYTE);
}

short int check8BitSW(short int number)
/*8bitsw 0,1,2,3,4,5,6,7̏Ԃ𒲂ׂ@number:0,1,2,3,4,5,6,or 7*/
/*ONȂ1AłȂ0Ԃ*/
{
	short int ret;
	static const unsigned char mask[]={1,2,4,8,0x10,0x20,0x40,0x80};
	if (P2.DR.BYTE&mask[number]) ret=0;
	else ret=1;
	return ret;
}

/*^C}荞݂͊}N(1998)CzqN(2001)ɂJł*/
/* ------------------------------------------------- */
/* TIMER INITIALIZATION */
/* ------------------------------------------------- */
void initTimer1Int(unsigned short int period)
/*ITU1ɂ銄荞݃^C}[̐ݒ(zqN2001ɂ)*/
/*荞݊Ԋu͈peiodŒPʂ̓secł*/
/*ʂɁCݒłperiod̍ől*/
/*@65535/(MHzŎNbNg)*8@ƂȂ*/
/*Ⴆ΁C25MHzłperiod20971ȉł20.971msec܂ł̐ݒ肪\*/

{
	unsigned int periodGRA=(unsigned int)((SYS_CLOCK*(long int)period+4)>>3);
	ITU1.TCR.BIT.CCLR=1;  /*GRÃRyA}b`TCNTNA*/
	ITU1.TCR.BIT.CKEG=0;  /*オGbWŃJEg*/
	ITU1.TCR.BIT.TPSC=3;  /*NbN/8ŃJEg*/
	ITU1.GRA=periodGRA-1;  /*荞݂̎period[s]Ɏw*/
	ITU1.TIER.BIT.IMIEA=1; /*TCNT=GRAƂȂƂ̊荞ݗv*/
	ITU1.TIER.BIT.OVIE=0;  /*I[o[EA_[t[̊荞݂֎~*/
	ITU1.TIER.BIT.IMIEB=0;  /*TCNT=GRBƂȂƂ̊荞݂֎~*/
}


/* ------------------------------------------------- */
/* TIMER START/STOP ClearFlag */
/* ------------------------------------------------- */
/*Timer CH1 X^[g*/
void startTimer1(void)
{
	ITU.TSTR.BYTE |= 0x02;
}

/*Timer CH1 Xgbv*/
void stopTimer1(void)
{
	ITU.TSTR.BYTE &= ~0x02;
}

/*Timer CH1 荞݃tÕNA*/
void clearTimer1Flag(void)
{
	ITU1.TSR.BIT.IMFA=0;
}
